#!/usr/bin/perl
use strict;
use warnings;
#use integer;
my $version=2;
#
#----------------------------------------
#Variables
#----------------------------------------
#dimensions refers to the dimension of a single cell
#The offsets give the location of the cell.
my %Xoffset_hash; my %Yoffset_hash;
my @spreadsheet_array;
my @identify_array; 
my $y=0;
my $which_white=72;
my $column; my $row;

#Do not move or alter the following line. The program transfer parameters depends on it.
#INSERT_COORDINATES_HERE
$Xoffset_hash{0}=99;$Yoffset_hash{0}=585;
$Xoffset_hash{1}=267;$Yoffset_hash{1}=585;
$Xoffset_hash{2}=438;$Yoffset_hash{2}=585;
$Xoffset_hash{3}=588;$Yoffset_hash{3}=585;
$Xoffset_hash{4}=753;$Yoffset_hash{4}=585;
$Xoffset_hash{5}=903;$Yoffset_hash{5}=585;
$Xoffset_hash{6}=1068;$Yoffset_hash{6}=585;
$Xoffset_hash{7}=1230;$Yoffset_hash{7}=585;
$Xoffset_hash{8}=1380;$Yoffset_hash{8}=585;
$Xoffset_hash{9}=1533;$Yoffset_hash{9}=585;
$Xoffset_hash{10}=1692;$Yoffset_hash{10}=585;
$Xoffset_hash{11}=1836;$Yoffset_hash{11}=585;

#how many cells are in photograph?
my $number_of_cells_per_image=12;
#dimensions of each cell
my $dimensions="129x411";
#Do not move or alter the following line. The program transfer parameters depends on it.
#END_COORDINATES

#batch number is here so that we can process them into subgroups.
my $number_of_batches;
#To what degree should we brighten the final image?
my $brightness_up=300;
#The first cell is cell zero, the next one is cell one. 
#$cell_number is the currnt cell that we are working with.
my $cell_number;
#Do you want debugging reports turned on? If this is a mystery to you then you don't want it on.
my $DEBUG=0;
my $x;

my $input_image1; my $input_image2; my $output_image;
my $cell_name;
my $formatted_number;

#@ARGV is an array that contains all of the command-line arguments.
#If it is empty, the test will fail, a suggestion will print and the program will exit.
#Use !=0 if you want just one argument. Use <1 is you want no fewer than 2 arguments.
#Use < 0 if you want 1 or more arguments.  Zero arguments gives a $#ARGV = -1.
# <3 means at least 4 arguments.
#This is how we handle wildcards. We let Bash handle the expansion of filenames.
#We just read them from $ARGV[];
if($#ARGV < 0)
{
	print "\n\n\n\n";
	print "|----------------------------November 9, 2006--------------------------------|\n";
	print " Program name: $0 *.jpg\n";
	print " version #$version\n";
	print "\n";
	print " *.jpg are your data files. They must all be in the same directory as $0.\n";
	print " My advice to you is that you should not keep anything else in this directory.\n";
	print " I will overwrite files if they get in my way!\n";
	print " I don't care how you use me, just please, please, USE ME!\n";
	print "|----------------------------by Nigel Atkinson--------------------------------|\n";
	exit; 
}
else
{
	print "version #$version\n";
}

#----------------------------------------------------
#open the outputfile which will store the spreadsheet
#This will be a tab delimited text file.
my $output_file;
$output_file="results.txt";
unless(open(OUTPUTFILE,">$output_file"))
{
	print("\ncannot open $output_file\n");
	exit;
}
#----------------------------------------------------

my $num_of_arg = @ARGV;
my @Files_to_process;

#$number_of_timepoints is the same for each cell.
#However, in the staggered version of the program (this one) each cell is added in consecutive images.
#So cell0 is added in the first picture, cell1 in picture 2, cell2 in picture 3, etc.
#So if we have 3 cells and we have taken 100 timeponts then we can only process 97 of those timepoints.
#In each case the first timepoint FOR EACH CELL is being subtracted from all of the rest. This should produce
#96 datapoints.
#For the first round of substractions for each cell this would be:
#image1cell0 - image0cell0, etc. AND image2cell1 - image1cell1, etc. AND image3cell2 - image2cell2, etc.)
#$number_of_timepoints gives the number of cells to manipulate but it does not tell us where to start our manipulations.
my $number_of_timepoints = ($num_of_arg-$number_of_cells_per_image);
print "number of image files found=$num_of_arg\n";
print "number_of_cells_per_image=$number_of_cells_per_image\n";
print "actual number_of_timepoints to be produced=$number_of_timepoints\n";

for($x=0;$x<$num_of_arg;$x++)
{
	$Files_to_process[$x]=$ARGV[$x];
	print "$Files_to_process[$x]\n";
	
	#convert to 256 colors
	#print "convert $Files_to_process[$x] -depth 8 $Files_to_process[$x]\n";
	print `convert $Files_to_process[$x] -depth 8 $Files_to_process[$x]`;
}

#$number_of_batches = ($num_of_arg)/$number_in_each_batch;
#print " number_of_batches = $number_of_batches\n";

#Process one cell at a time
#cell_number is the current cell that we are working on.
for($cell_number=0; $cell_number<$number_of_cells_per_image; $cell_number++)
{
	print "cell$cell_number, number_of_cells_per_image=$number_of_cells_per_image, (Xoffset,Yoffset)=($Xoffset_hash{$cell_number},$Yoffset_hash{$cell_number}) number_of_timepoints=$number_of_timepoints\n";
	
	#Insert the column names into the spreadsheet array
	$spreadsheet_array[$cell_number][0]= "cell$cell_number";

	my $final_cell=$num_of_arg-$cell_number;
	for($x=0; $x<($final_cell); $x++)
	{
		#This loop crops and simultaneously converts to jpg.
		#The blank for cell_number 0 is in $Files_to_process[0].
		#The blank for cell_number 1 is in $Files_to_process[1].
		$input_image1=$Files_to_process[($x+$cell_number)];
		
		#The next line is the reason that the loop must count from 0 to the $final cell number.
		#This makes all of the consecuitively added tubes equivalent.
		#They must be consequitively numbered from zero for the next loop to work properly.
		$output_image="crop$cell_number.$x.jpg";
		#print "convert -crop $dimensions+$Xoffset_hash{$cell_number}+$Yoffset_hash{$cell_number} $input_image1 $output_image\n";
		print `convert -crop $dimensions+$Xoffset_hash{$cell_number}+$Yoffset_hash{$cell_number} $input_image1 $output_image`;
	}#end of cropping loop
	
	#The next loop begins with 1 because 0 contains the first image which is too be subtracted from each and every
	#image in the series.
	for($x=1; $x<($number_of_timepoints+1); $x++)
	{
		
		$input_image1="crop$cell_number.0.jpg";
		$input_image2="crop$cell_number.$x.jpg";
		#$output_image="diff$cell_number.$x.jpg";

		#output_image has been replaced with cell name.
		# Format batch number with 3 digits
		$formatted_number = sprintf("%05d", $x);
		$cell_name="cell_$cell_number.$formatted_number.jpg";
		
		print `composite -compose difference $input_image1 $input_image2 $cell_name`;

		#grayscale
		print `convert $cell_name -colorspace gray $cell_name`;
		
		#turn up brightness/contrast
		print `mogrify -modulate $brightness_up $cell_name`;

		#Harvest the information from the file. This contains the white values.
		@identify_array= `identify -verbose $cell_name`; 
		
		print "$cell_name image manipulated\n";
		
		my $white=0;
		for($y=0; $y<@identify_array; $y++)
		{
	  		#  Histogram:
    			#    247541: (  0,  0,  0)	black
      			#      2459: (240,240,240)	grey94
 	        	#	5: ( 87, 87, 87)	grey34
			#This will harvest the black number.
			#if($array[$y]=~/\w+(\d+):\s\(\s*\d+,\s*\d+,\s*\d+\)\s*black$/)
			#{
				#$black=$1;
			#}
			#Let's use grey29 as a default. I think that grey 29 is ( 72, 72, 72).
			#In the statement below we really don't need to capture $2, $3 & $4. However, we might be able to use it
			#as a way to confirm that all of the values are the same. If this is grey scale then all should be
			#the same value.
			if($identify_array[$y]=~/\s*(\d+): \(\s*(\d+),\s*(\d+),/)
			{ 
				#Now collect all of the greys that we want to call white.
				#First guess was 72
				#$which_white contains the white value to be used. You can define it at the beginning of the program.
				if($2>=$which_white)
				{
					$white=$white+$1;
					#print "\n$1: ( $2,$3,$4)\n";
				}
			}
		}
		#$cell_number is how we want each column in the spreadsheet to begin.
		#It would be nice to store this in an 2 dim array.
		#spreadsheet_array[column][row] where the columns are different cells and the row are differnt times.
		$spreadsheet_array[$cell_number][$x]= "$white";
	}#end of batch loop

}#end of cell for loop

#remove old files
print `rm crop*`;

for $row(0 .. ($number_of_timepoints))
{
	for $column(0 .. $#spreadsheet_array)
	{
		#for $row(1 .. $#{$spreadsheet_array[$column]})
		print OUTPUTFILE $spreadsheet_array[$column][$row]."\t";
	}
	print OUTPUTFILE "\n";
}
#
#
#
print "Termino\n";
exit;
#Notes
#The command for changing 16-bit (65536 colors) to 8-bit (256 colors) is:
#mogrify -depth 8 *.png
#	or 
#convert input_file.png -depth 8 output_file.png 
#The "-depth" command can have one of two arguments, 8 or 16.  8 bit 
#corresponds to 2^8 colors, and 16 is 2^16 colors. 

#convert everyone to 256 colors
#print "mogrify -depth 8 *.jpg\n";
#print `mogrify -depth 8 *.jpg`;

#convert 1.3.0.png -fill white -opaque black out.png
#convert 1.3.0.png -fill white -fuzz 5% -opaque black out.png
#convert 1.3.0.png -fill yellow4 -fuzz 50% -opaque white out.png
